#ifndef MICROFACET_DIST_H
#define MICROFACET_DIST_H

#include "math/matrix.h"

class CMicrofacetDistribution {
public:
  // MicrofacetDistribution Interface
  CMicrofacetDistribution();
  virtual ~CMicrofacetDistribution ();
  virtual double D(const Vector& wh, const Vector& Normal ) const = 0;
  virtual void Sample_f( const Vector& Out, Vector& In, const Vector& Normal, double u1, double u2, float& Pdf ) const = 0;
  virtual float GetPDF(const Vector& Out, const Vector& In, const Vector& Normal ) const = 0;
};

#endif
// vim:ts=2
