////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// F A R M     -  Flair advanced rendering module
//
// Copyright European Organization for Nuclear Research( CERN )
// All rights reserved
//
// Authors: Christian.Theis@cern.ch
//			    Vasilis.Vlachoudis@cern.ch
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef SPECTRA_HELPERS_H
#define SPECTRA_HELPERS_H

#include "graph/color.h"

class CSpectraHelpers
{
public:

  static void  XYZToRGP(const double x, const double y, const double z, Color& Col);
  static void  WL2RGBFromCIE( const double wl, Color& Col);
  static void  ApproxSpectrum( const double wl, Color& Col);
  static void  FakeSpectrum( const double p, Color& Col);
  static void  CauchyCoefficients( const double IOR, const double disp_pw, double& CauchyA, double& CauchyB);
  static double GetIORColor( const double w, const double CauchyA, const double CauchyB, Color& Col);
};


#endif
// vim:ts=2
