/**
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	10-Oct-2018
 */

// FIXME TO BE REMOVED!!!!!

#ifndef __GEOMETRY_GEOCACHE_H
#define __GEOMETRY_GEOCACHE_H

#include "tool/cache.h"
#include "geometry/gbody.h"

// =============================== GeometryCache ===============================
/** Geometry Cache class */
class GeometryCache {
public:
	const GBody*	xbody;		/** last body crossed	*/
	Cache<CBody3D>	bodies3D;	/** geometry caching	*/
private:
	double	x,y,z;			/** remember position	*/
	double	u,v,w;			/** remember direction	*/

public:
	GeometryCache() : xbody(NULL),
		x(INFINITE), y(INFINITE), z(INFINITE),
		u(INFINITE), v(INFINITE), w(INFINITE)
		{}
	~GeometryCache() {}

	void	resize(const size_t n)	{ bodies3D.resize(n); }
	int	inc()			{ return bodies3D.inc(); }
	int	incIfChanged(const double ax, const double ay, const double az,
			     const double au, const double av, const double aw) {
				if (x==ax and y==ay and z==az and
				    u==au and v==av and w==aw) return -1;
				store(ax,ay,az, au,av,aw);
				return inc();
			}

	void	store(	const double ax, const double ay, const double az,
			const double au, const double av, const double aw) {
				x = ax;
				y = ay;
				z = az;
				u = au;
				v = av;
				w = aw;
			}
#ifdef STRONG
	void	_assert(const double ax, const double ay, const double az,
			const double au, const double av, const double aw) {
				assert(x==ax);
				assert(y==ay);
				assert(z==az);
				assert(u==au);
				assert(v==av);
				assert(w==aw);
			}
#endif
}; // class GeometryCache

#endif
