/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Please look at the supplied documentation for the user's
 * license
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	19-Jun-2013
 */

#ifndef __GMESH_H
#define __GMESH_H

#include <Python.h>

#include <X11/X.h>
#include <X11/Xutil.h>

#include "gobject.h"
#include "math/bbox.h"
#include "geometry/geo.h"
#include "geometry/mesh.h"
#include "geometry/geometry.h"
#include "viewer/viewer.h"

/** GMesh */
class GMesh : public GObject {
public:
	Mesh	mesh;

public:
	GMesh(const char *aname=NULL, ObjectType o=Mesh_Default) : GObject(aname, o) {};
	virtual ~GMesh() {}

	virtual ClassType isA()		const	{ return GMeshClass; }
	virtual const char* typeStr()	const	{ return "mesh"; }
	virtual	PyObject* config(const char *key, PyObject *value=NULL);

	// nodes
	virtual int nodes() const { return 1; }

	virtual void draw(ViewerObject *self, Drawable drawable);
}; // GMesh

#endif
