/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Set of low discrepancy sampling functions as well as several geometric samplers
 *
 * Author:	Christian.Theis@cern.ch
 * Date:	26-Mar-2020
 */

#include <vector>

#include "randsampler.h"


////////////////////////////////////////////////////////////////////////////////////////////////

void Shuffle( float* pSamp, unsigned long count, int dims, unsigned long randNr ) {

////////////////////////////////////////////////////////////////////////////////////////////////
	for( unsigned long i = 0; i < count; ++i ) {
		unsigned long other = randNr % count;
		for( int j = 0; j < dims; ++j )
			std::swap( pSamp[dims * i + j], pSamp[dims * other + j] );
	}
}