/**
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	30-Jan-2019
 */

#include "stat.h"
#include <iomanip>

#ifdef STAT
/** operator <<  */
std::ostream& operator << (std::ostream& os, const Stat& stat)
{
	unsigned maxlen = stat.maxlength();

	for (auto it : stat.counter) {
		os << "\t" << std::setw(maxlen) << std::left << it.first
		   << " : " << it.second;
		if (stat.totaltime.find(it.first) != stat.totaltime.end()) {
			const auto& t = stat.totaltime.at(it.first);
			double dt = (double)t.tv_sec + (double)t.tv_nsec/1e9;
			os << "\tTime: " << dt << " s";
			os << "\tAvg: " << dt / (double)it.second << " s";
		}
		os  << std::endl;
	}
	return os;
} // operator <<
#endif
